/* Generated from EXTERNALBUG.cob by cobc 0.23 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <libcob.h>

/* Fields */

#define i_LINAGE_COUNTER cob_linage_counter

static int i_RETURN_CODE = 1;

/* solution of the problem:  mapping "COBOL datafield IS EXTERNAL" TO  "C"
        ==> tentative Definiton of the "GROUP-FIELD"  
            and no initializations of the members !!! 
            (NO VALUE allowed in "IS EXTERNAL" datafields !)
        
   ANSI C 89 - tentative definition: scope file, (implizit external-linkage),
   repetition are allowed !!!  */
unsigned int EXTERNAL_GROUP_FIELD [34];

/* another implementation would be :

 #include "EXTERNALBUG.c_ext.h"

 (= contains only "01 GROUP-FIELD IS EXTERNAL"  ==> tentative definitions)

*/

/* the following repetition is here only a demo !!! */
unsigned int EXTERNAL_GROUP_FIELD [34];

int
EXTERNALBUG ()
{
  static int initialized = 0;
  static cob_decimal d[0];
  static cob_module module = {'.', '$', ',', 0, 0, 0, 1, 1, 0};

  int i;
  int i1, i2, i3, i4, i5, i6, i7;
  int n[0];
  int frame_index;
  struct frame { int perform_through; void *return_address; } frame_stack[254];
  cob_field f[4];

#include "EXTERNALBUG.c.h"

  cob_module_enter (&module);

  if (!initialized)
    {
      i_RETURN_CODE = 0;
      /* initialize decimal numbers */
      for (i = 0; i < 0; i++)
        cob_decimal_init (&d[i]);

      initialized = 1;
    }
  memset (b_FIRST_VARIABLE, 32, 1);

/* 
   no initialization necessary in a COBOL mainprogram !
      BUT really faulty in a COBOL subprogram !!!!

   the initialization here would not disturb;
   ==> behavior would also be "COBOL ANSI - 85" conform

   so we have here a choice ; 
     ==> please implement what you prefer!

  memset (EXTERNAL_GROUP_FIELD, 32, 30);
  memset (EXTERNAL_GROUP_FIELD + 30, 48, 4);
*/

  /* initialize frame stack */
  frame_index = 0;
  frame_stack[0].perform_through = -1;

  goto l_E$EXTERNALBUG;

  /* error handlers */

  /* standard_error_handler: */
  l_standard_error_handler:
  switch (cob_error_file->last_open_mode)
    {
    default:
      cob_default_error_handle ();
      break;
    }
  if (frame_stack[frame_index].perform_through == 0)
    goto *frame_stack[frame_index].return_address;

  /* PROCEDURE DIVISION */

  /* EXTERNALBUG: */
  l_E$EXTERNALBUG:

  /* BEGIN: */
  /* MOVE */
#line 11 "EXTERNALBUG.cob"
  cob_move (&c_1, &f_EXTERNAL_GROUP_FIELD$ALPHA_FIELD);
  /* DISPLAY */
#line 14 "EXTERNALBUG.cob"
  {
    cob_display (&c_2);
    cob_newline ();
  }
  /* DISPLAY */
#line 15 "EXTERNALBUG.cob"
  {
    cob_display (&c_3);
    cob_display (&f_EXTERNAL_GROUP_FIELD$ALPHA_FIELD);
    cob_newline ();
  }
  /* CALL */
#line 17 "EXTERNALBUG.cob"
  {
    int (*func)();
    func = cob_resolve ("UPROG");
    if (func == NULL)
      cob_call_error ();
    else
      {
        i_RETURN_CODE = func ();
      }
  }
  /* DISPLAY */
#line 19 "EXTERNALBUG.cob"
  {
    cob_display (&c_4);
    cob_newline ();
  }
  /* DISPLAY */
#line 20 "EXTERNALBUG.cob"
  {
    cob_display (&c_3);
    cob_display (&f_EXTERNAL_GROUP_FIELD$ALPHA_FIELD);
    cob_newline ();
  }
  /* STOP */
#line 22 "EXTERNALBUG.cob"
  cob_stop_run (i_RETURN_CODE);

  exit_program:
  cob_module_leave (&module);
  return i_RETURN_CODE;
}

int
main (int argc, char **argv)
{
  int ret;
  cob_init (argc, argv);
  ret = EXTERNALBUG ();
  return ret;
}
